﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	
	Private bc As BitmapCreator
	
	Dim nativeMe As JavaObject
	Dim bm1, bm2 As Bitmap

	Private ImageView1 As ImageView
	Private ImageView2 As ImageView
	Dim anchopantalla As Int = 60
	Dim altopantalla As Int = 60
	Dim map_origen,map_destino As Map
End Sub

Public Sub Initialize
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("main")
	Root.Color=Colors.LightGray
	nativeMe.InitializeContext
	
	
	
	
	'DRAW A SIMPLE IMAGE WITH A COLOURS
	map_origen.Initialize
	Dim bc As BitmapCreator
	bc.Initialize(anchopantalla, altopantalla)
	Dim xx=0, yy=1 As Int
	Dim idcolor As Int
	For R = 0 To 255 Step 2
		For G = 0 To 255 Step 2
			For B = 0 To 255 Step 2
				xx=xx+1
				If xx>=anchopantalla Then
					yy=yy+1
					xx=1
					Log(yy)
				End If
				If yy>=altopantalla Then
					R=255
					G=255
					B=255
					Exit
				End If
				idcolor = Colors.RGB(R, G, B)
				bc.SetColor(xx,yy,idcolor)
				map_origen.Put(idcolor, xx & "," & yy)
			Next
		Next
	Next
	bm1=bc.Bitmap
	ImageView1.Bitmap=bm1
	ImageView1.Gravity=Gravity.fill



	'TRANSFORMATION CORRECTION IMAGE
	Dim source() As Float = Array As Float(4.0, 4.0, 29.0, 16.0, 27.0, 37.0, 5.0, 20.0)
	Dim destination() As Float = Array As Float(0, 0, anchopantalla, 0, anchopantalla, altopantalla, 0, altopantalla)
	bm2 = nativeMe.RunMethod("perspectiveTransformation", Array(bm1, source, destination))
	ImageView2.Bitmap = bm2
	Sleep(1000)
	



	'UPDATE X-Y ORIGEN-DESTINATION
	Dim pixelcolor As Int
	Dim coordenadasorigen As String
	map_destino.Initialize
	Dim img As B4XBitmap = ImageView2.Bitmap
	Dim bc As BitmapCreator
	bc.Initialize(img.Width, img.Height)
	bc.CopyPixelsFromBitmap(img)

	For y = 0 To bc.mHeight - 1 Step 1
		For x = 0 To bc.mWidth - 1 Step 1
			pixelcolor = bc.GetColor(x, y)
			coordenadasorigen = map_origen.Get(pixelcolor)
			If coordenadasorigen<>"null" Then
				map_destino.Put(coordenadasorigen, x & "," & y)
			End If
		Next
		Log(" y=" & y )
	Next
	map_origen.Clear




	'SHOW RESULT COORDINATES RELATION CORRECTION
	For i = 0 To map_destino.SIZE-1
		Log("ORIGEN XY: " & map_destino.GetKeyAt(i) & "-> DESTINATION XY CORRECTION: " & map_destino.GetValueAt(i))
	Next
End Sub
